/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This is the disk image base class.
 *
 */
class GalleryDiskImage {
  /**
   * Create a GalleryDiskImage.
   * @member {number} [sizedInGB] It indicates the size of the VHD to create.
   * @member {string} [hostCaching] The host caching of the disk. Valid values
   * are 'None', 'ReadOnly', and 'ReadWrite'. Possible values include: 'None',
   * 'ReadOnly', 'ReadWrite'
   */
  constructor() {
  }

  /**
   * Defines the metadata of GalleryDiskImage
   *
   * @returns {object} metadata of GalleryDiskImage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryDiskImage',
      type: {
        name: 'Composite',
        className: 'GalleryDiskImage',
        modelProperties: {
          sizedInGB: {
            required: false,
            serializedName: 'sizedInGB',
            type: {
              name: 'Number'
            }
          },
          hostCaching: {
            required: false,
            serializedName: 'hostCaching',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'ReadOnly', 'ReadWrite' ]
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryDiskImage;
