/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The publishing profile of a gallery image version.
 *
 * @extends models['GalleryArtifactPublishingProfileBase']
 */
class GalleryImageVersionPublishingProfile extends models['GalleryArtifactPublishingProfileBase'] {
  /**
   * Create a GalleryImageVersionPublishingProfile.
   * @member {boolean} [excludeFromLatest] The flag means that if it is set to
   * true, people deploying VMs with 'latest' as version will not use this
   * version.
   * @member {date} [publishedDate] The time when the gallery image version is
   * published.
   * @member {date} [endOfLifeDate] The end of life date of the gallery image
   * version.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of GalleryImageVersionPublishingProfile
   *
   * @returns {object} metadata of GalleryImageVersionPublishingProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryImageVersionPublishingProfile',
      type: {
        name: 'Composite',
        className: 'GalleryImageVersionPublishingProfile',
        modelProperties: {
          regions: {
            required: false,
            serializedName: 'regions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          source: {
            required: false,
            serializedName: 'source',
            type: {
              name: 'Composite',
              className: 'GalleryArtifactSource'
            }
          },
          excludeFromLatest: {
            required: false,
            serializedName: 'excludeFromLatest',
            type: {
              name: 'Boolean'
            }
          },
          publishedDate: {
            required: false,
            readOnly: true,
            serializedName: 'publishedDate',
            type: {
              name: 'Date'
            }
          },
          endOfLifeDate: {
            required: false,
            serializedName: 'endOfLifeDate',
            type: {
              name: 'Date'
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryImageVersionPublishingProfile;
